function dout=gui(d)

%figure
hFig = figure('Units','points', ...
	'Color',[0.8 0.8 0.8], ...
	'FileName','D:\apps\Matlab\myfunc\@dataframe\gui.m', ...
	'PaperPosition',[18 180 576 462], ...
	'PaperUnits','points', ...
    'Position',[20 100 180 300], ...
    'DeleteFcn','clear global EXPLR_DEP; clear global EXPLR_LATS; clear global EXPLR_LONS; clear global EXPLR_LEGEND',...
	'Tag','Fig1', ...
    'Name',inputname(1),...
    'ToolBar','none',...
    'UserData',d.transform);
set(hFig,'MenuBar','none');

cn=colnames(d,1);
%dependent listbox
hlbDep = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[33 240 123 25], ...
	'String',{'(none)' cn{:}}, ...
	'Style','popupmenu', ...
    'Tag','dep', ...
    'Max',3,'Min',1,...
    'Value',1);
%dependent listbox title
h1 = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'FontSize',14, ...
	'ListboxTop',0, ...
	'Position',[20 270 150 15], ...
	'String','Dependent variable', ...
	'Style','text', ...
    'Tag','DepLabel');

 
%vars listbox
hlbVars = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[33 80 123 140], ...
	'String',cn, ...
	'Style','listbox', ...
    'Tag','vars', ...
    'Max',3,'Min',1,...
    'Value',1);
%listbox title
h1 = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'FontSize',14, ...
	'ListboxTop',0, ...
	'Position',[33 220 118.5 15], ...
	'String','Variables', ...
	'Style','text', ...
    'Tag','StaticText1');
 
%transform pushbutton then popup
trans={'(none)'};
for i=1:3,
    trans={trans{:} transstr(i)};
end
global hpuTrans;
hpuTrans = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[80 40 60 25], ...
	'String',trans, ...
	'Style','popupmenu', ...
	'Tag','trans', ...
    'Value',1,...
    'Callback',[...
        'nt=get(gcbo,''Value'')-1;',...
        'ntl=get(gcbo,''String'');',...
        'ntl=ntl{nt+1};',...
        'if (nt==0), ntl='''';end;',...
        'htxtT=findobj(gcf,''Tag'',''transplustxt'');',...
        'hedT=findobj(gcf,''Tag'',''transplus'');',...
        'if (nt==1), set(htxtT,''Visible'',''on'' );set(hedT,''Visible'',''on'' ); end;',...
        'if (nt~=1), set(htxtT,''Visible'',''off'');set(hedT,''Visible'',''off''); end;',...
        'if (nt==1), v=get(hedT,''String''); if ~isempty(v), nt=-str2num(v); ntl=[ntl ''+'' v];end;end;',...
        'hList=findobj(gcf,''Tag'',''vars'');',...
        'cn=get(hList,''String'');',...
        'sel=get(hList,''Value'');',...
        'tr=get(gcf,''UserData'');',...
        'for i=sel,',...
        '    tr(i)=nt;',...
        '    cn{i}=[cn{i}(1:(strfind(cn{i},''('')-1)) ''('' ntl '')''];',...
        'end;',...
        'set(hList,''String'',cn);',...
        'set(gcf,''UserData'',tr);'...
    ]);
 h5 = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[5 50 70 15], ...
	'String','Transformation:', ...
	'Style','text', ...
    'Tag','StaticText1');
%+transofrmation
hedTransPlus = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[150 50 30 15], ...
	'String','', ...
	'Style','edit', ...
    'Visible','off',...
	'Tag','transplus' ...
);
htxtTransPlus = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[140 50 10 15], ...
	'String','+', ...
	'Style','text', ...
    'Visible','off',...
    'Tag','transplustxt');



h1 = uicontrol('Parent',hFig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'ListboxTop',0, ...
	'Position',[40 5 100 20], ...
    'String','OK', ...
    'Callback',['uiresume'],...
	'Tag','OK');

hchkConst=uicontrol('Parent',hFig,'Style','checkbox','Units','Points',...
    'Position',[40 230 80 15],'String','Constant','Tag','Const');


uiwait;
%parse
d.transform=get(hFig,'UserData');
s=[];idx=0;
cn=colnames(d,0);
selvars=get(hlbVars,'Value');
dep=get(hlbDep,'Value');
for i=selvars,
    if i==dep, continue; end
    idx=idx+1;
    s(idx).type='.';
    s(idx).subs=cn{i};
end
if get(hchkConst,'Value'), 
    idx=idx+1;
    s(idx).type='.';
    s(idx).subs='const';
end
if dep>1,
    idx=idx+1;
    s(idx).type='.';
    s(idx).subs='dep';
    idx=idx+1;
    s(idx).type='{}';
    s(idx).subs={cn{dep-1}};
end
dout=subsref(d,s);

%return result
delete(hFig);
